local L = AceLibrary("AceLocale-2.2"):new("TrapBar")

L:RegisterTranslations("enUS", function() return {
	["TrapBar"] = true,
	["Config"] = true,
	["Set Config"] = true,
	["Scale"] = true,
	["Set Scale"] = true,
	["Alpha"] = true,
	["Set Alpha"] = true,
	["Button"] = true,
	["Select button displayed"] = true,
	["Show %s button"] = true,
	["Bar Config"] = true,
	["Set Bar Appearnce"] = true,
	["Direct"] = true,
	["Set Direct"] = true,
	["Vertical"] = true,
	["Horizontal"] = true,
	["Order"] = true,
	["Set Order"] = true,
	["Normal"] = true,
	["Reverse"] = true,
	["Show"] = true,
	["Config %s Button"] = true,
	["Adjust button order"] = true,
	["Binding"] = true,
	["Set %s button binding key"] = true,
	["Help"] = true,
	["To move bar, Ctrl+Right Drag button\nTo change button order, use button show function."] = true,
} end)


local BS = AceLibrary("Babble-Spell-2.2")
TrapBar = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0");


local TrapBarOptionTable = {
	name = L["TrapBar"],
	desc = L["TrapBar"],
	type = "group",
	args = {
		Help = {
			name = L["Help"],
			desc = L["Help"],
			type = 'execute',
			func = function()
				TrapBar:Print(L["To move bar, Ctrl+Right Drag button\nTo change button order, use button show function."])
			end,
		},
		Config = {
			name = L["Config"],
			desc = L["Set Config"],
			type = "group",
			args = {
				Scale = {
					name = L["Scale"],
					desc = L["Set Scale"],
					type = "range",
					min = 0.1,
					max = 2.5,
					step = 0.1,
					get = function() return TrapBar.db.profile.Scale end,
					set = function(v)
						TrapBar.db.profile.Scale = v
						TrapBar:SetUp()
						TrapBarFrame:Show();
					end,
				},
				Alpha = {
					name = L["Alpha"],
					desc = L["Set Alpha"],
					type = "range",
					min = 0.0,
					max = 1.0,
					step = 0.05,
					get = function() return TrapBar.db.profile.Alpha end,
					set = function(v)
						TrapBar.db.profile.Alpha = v
						TrapBar:SetUp()
						TrapBarFrame:Show();
					end,
				},
				Bar = {
					name = L["Bar Config"],
					desc = L["Set Bar Appearnce"],
					type = "group",
					args = {
						Direct = {
							name = L["Direct"],
							desc = L["Set Direct"],
							type = "text",
							get = function() return TrapBar.db.profile.Direct end,
							set = function(v) 
								TrapBar.db.profile.Direct = v
								TrapBar:SetUp()
								TrapBarFrame:Show();
							end,
							validate = {["Vertical"] = L["Vertical"], ["Horizontal"] = L["Horizontal"]}
						},
						Order = {
							name = L["Order"],
							desc = L["Set Order"],
							type = "text",
							get = function() return TrapBar.db.profile.Reverse end,
							set = function(v) 
								TrapBar.db.profile.Reverse = v
								TrapBar:SetUp()
								TrapBarFrame:Show();
							end,
							validate = {["Normal"] = L["Normal"], ["Reverse"] = L["Reverse"]}
						},
					},
				},
				Button = {
					name = L["Button"],
					desc = L["Select button displayed"],
					type = 'group',
					args = {
						Explosive = {
							name = BS["Explosive Trap"],
							desc = (L["Config %s Button"]):format( BS["Explosive Trap"]),
							order = 1,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Explosive Trap"]),
									disabled = function() return InCombatLockdown() end,
									type = 'toggle',
									get = function() return TrapBar.db.profile.Explosive.Show end,
									set = function()
										TrapBar.db.profile.Explosive.Show = not TrapBar.db.profile.Explosive.Show
										TrapBar:SetButtonNum(TrapBar.db.profile.Explosive.Show, BS["Explosive Trap"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Explosive Trap"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Explosive Trap"]) end,
									set = function(v)
										TrapBar:SetBinding(BS["Explosive Trap"], v)
									end,
								},
							},
						},
						Freezing = {
							name = BS["Freezing Trap"],
							desc = (L["Config %s Button"]):format( BS["Freezing Trap"]),
							order = 2,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Freezing Trap"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrapBar.db.profile.Freezing.Show end,
									set = function()
										TrapBar.db.profile.Freezing.Show = not TrapBar.db.profile.Freezing.Show
										TrapBar:SetButtonNum(TrapBar.db.profile.Freezing.Show, BS["Freezing Trap"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Freezing Trap"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Freezing Trap"]) end,
									set = function(v)
										TrapBar:SetBinding(BS["Freezing Trap"], v)
									end,
								},
							},
						},
						Frost = {
							name = BS["Frost Trap"],
							desc = (L["Config %s Button"]):format( BS["Frost Trap"]),
							order = 3,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Frost Trap"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrapBar.db.profile.Frost.Show end,
									set = function()
										TrapBar.db.profile.Frost.Show = not TrapBar.db.profile.Frost.Show
										TrapBar:SetButtonNum(TrapBar.db.profile.Frost.Show, BS["Frost Trap"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Frost Trap"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Frost Trap"]) end,
									set = function(v)
										TrapBar:SetBinding(BS["Frost Trap"], v)
									end,
								},
							},
						},
						Immolation = {
							name = BS["Immolation Trap"],
							desc = (L["Config %s Button"]):format( BS["Immolation Trap"]),
							order = 4,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Immolation Trap"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrapBar.db.profile.Immolation.Show end,
									set = function()
										TrapBar.db.profile.Immolation.Show = not TrapBar.db.profile.Immolation.Show
										TrapBar:SetButtonNum(TrapBar.db.profile.Immolation.Show, BS["Immolation Trap"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Immolation Trap"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Immolation Trap"]) end,
									set = function(v)
										TrapBar:SetBinding(BS["Immolation Trap"], v)
									end,
								},
							},
						},
						Snake = {
							name = BS["Snake Trap"],
							desc = (L["Config %s Button"]):format( BS["Snake Trap"]),
							order = 5,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Snake Trap"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrapBar.db.profile.Snake.Show end,
									set = function()
										TrapBar.db.profile.Snake.Show = not TrapBar.db.profile.Snake.Show
										TrapBar:SetButtonNum(TrapBar.db.profile.Snake.Show, BS["Snake Trap"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Snake Trap"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Snake Trap"]) end,
									set = function(v)
										TrapBar:SetBinding(BS["Snake Trap"], v)
									end,
								},
							},
						},
					},
				},
			},
		},
	}
}

function TrapBar:OnInitialize()
	local defaults = {
		Scale = 1,
		Alpha = 1,
		Direct = "Horizontal",
		Reverse = "Normal",
		Explosive = {Show = true, Order = 1},
		Freezing = {Show = true, Order = 2},
		Frost = {Show = true, Order = 3},
		Immolation = {Show = true, Order = 4},
		Snake = {Show = true, Order = 5},
		Number = 5,
		TrapList = {
			[1] = BS["Explosive Trap"],
			[2] = BS["Freezing Trap"],
			[3] = BS["Frost Trap"],
			[4] = BS["Immolation Trap"],
			[5] = BS["Snake Trap"],
			[6] = nil,
		}
	}

	self:RegisterDB("TrapBarDB")
	self:RegisterDefaults('profile', defaults)
	self:RegisterChatCommand('/trapbar', TrapBarOptionTable)

	TrapBar:SetUp()
end

function TrapBar:SetTooltip()
	if (this:GetAttribute("id")) then
		GameTooltip_SetDefaultAnchor(GameTooltip, this);
		GameTooltip:SetSpell(this:GetAttribute("id"), SpellBookFrame.bookType);
		GameTooltip:Show();
	end
end

function TrapBar:SetButtonNum(value, asp)
	if value == true then
		TrapBar.db.profile.Number = TrapBar.db.profile.Number  + 1
		if not TrapBar.db.profile.TrapList then
			TrapBar.db.profile.TrapList = { }
		end
		TrapBar.db.profile.TrapList[TrapBar.db.profile.Number] = asp
--		tinsert(TrapBar.db.profile.TrapList, TrapBar.db.profile.Number, asp)
		getglobal("TrapBarButton"..TrapBar.db.profile.Number):Show()
	else
		TrapBar.db.profile.Number = TrapBar.db.profile.Number  - 1
		getglobal("TrapBarButton"..TrapBar.db.profile.Number + 1):Hide()
		for k, v in pairs(TrapBar.db.profile.TrapList) do
			if v == asp then
--				tremove(TrapBar.db.profile.TrapList, k)
				for i = k, 5 do
					TrapBar.db.profile.TrapList[i] = TrapBar.db.profile.TrapList[i+1]
				end
			end
		end
	end
	TrapBar:UPDATE()
end

function TrapBar:SetBinding(asp, bind)
	local clear1, clear2 = GetBindingKey("SPELL "..asp)
	if clear1 then
		SetBinding(clear1)
	end
	if clear2 then
		SetBinding(clear2)
	end
	SetBinding(bind)
	SetBindingSpell(bind, asp)
	SaveBindings(GetCurrentBindingSet())
end

function TrapBar:SetOrder(as, o)
	
end

function TrapBar:GetSpellID(spell, rank)
	local i = 1;
	local spellID, highestRank;
	while true do
		local spellName, spellRank = GetSpellName(i, SpellBookFrame.bookType);
		if (not spellName) then
			break;
		end
		if (spellName == spell) then
			if (rank) then
				if (spellRank == rank) then
					return i;
				end
			else
				spellID = i;
				highestRank = spellRank;
			end
		end
		i = i + 1;
		if (i > 250) then
			break;
		end
	end			
	return spellID, highestRank;
end

function TrapBar:OnEnable()
	self:RegisterEvent("SPELLS_CHANGED", "UPDATE")
	self:RegisterEvent("PLAYER_AURAS_CHANGED", "UPDATE")
	self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
end

function TrapBar:SetUp()
	-- This function cannot be performed in combat.
        if (InCombatLockdown() == nil) then
		if (TrapBar.db.profile) then
			if TrapBar.db.profile.Number > 1 then
				if (TrapBar.db.profile.Direct == "Vertical" and TrapBar.db.profile.Reverse == "Normal") then
					for i = 2, TrapBar.db.profile.Number do
						local button = getglobal("TrapBarButton"..i);
						button:ClearAllPoints();
						button:SetPoint("TOP", "TrapBarButton"..i - 1, "BOTTOM", 0, 1);
					end
				elseif (TrapBar.db.profile.Direct == "Vertical" and TrapBar.db.profile.Reverse == "Reverse") then
					for i = 2, TrapBar.db.profile.Number do
						local button = getglobal("TrapBarButton"..i);
						button:ClearAllPoints();
						button:SetPoint("BOTTOM", "TrapBarButton"..i - 1, "TOP", 0, 1);
					end
				elseif (TrapBar.db.profile.Direct == "Horizontal" and TrapBar.db.profile.Reverse == "Normal") then
					for i = 2, TrapBar.db.profile.Number do
						local button = getglobal("TrapBarButton"..i);
						button:ClearAllPoints();
						button:SetPoint("LEFT", "TrapBarButton"..i - 1, "RIGHT", 1, 0);
					end
				elseif (TrapBar.db.profile.Direct == "Horizontal" and TrapBar.db.profile.Reverse == "Reverse") then
					for i = 2, TrapBar.db.profile.Number do
						local button = getglobal("TrapBarButton"..i);
						button:ClearAllPoints();
						button:SetPoint("RIGHT", "TrapBarButton"..i - 1, "LEFT", 1, 0);
					end
				else
					for i = 2, TrapBar.db.profile.Number do
						local button = getglobal("TrapBarButton"..i);
						button:ClearAllPoints();
						button:SetPoint("LEFT", "TrapBarButton"..i - 1, "RIGHT", 1, 0);
					end
				end
			end
			if TrapBar.db.profile.Scale then
				TrapBarFrame:SetScale(TrapBar.db.profile.Scale)
			else
				TrapBarFrame:SetScale(1)
			end
			if TrapBar.db.profile.Alpha then
				TrapBarFrame:SetAlpha(TrapBar.db.profile.Alpha)
			else
				TrapBarFrame:SetAlpha(1)
			end

		end
	end
end

function TrapBar:UPDATE()
	local i, button, p, l;
	if (TrapBar.db.profile) then
		i = 0;
		-- This function cannot be performed in combat.
		if (InCombatLockdown() == nil) then
			for key in pairs(TrapBar.db.profile.TrapList) do
				if getglobal("TrapBarButton"..key) then
					getglobal("TrapBarButton"..key):Hide();
				end
			end
			TrapBar:SetUp()
			TrapBarFrame:Show();
		end
		for key, value in pairs(TrapBar.db.profile.TrapList) do
			local id = TrapBar:GetSpellID(value);
			if (id) then
				i = i + 1;
 				button = getglobal("TrapBarButton"..i);
				-- This function cannot be performed in combat.
        			if (InCombatLockdown() == nil) then
					if button then
						button:SetAttribute("type", "spell");
						button:SetAttribute("spell", value);
					end
				end

  				local texture = GetSpellTexture(id, BOOKTYPE_SPELL);
				for z = 0, 7 do
					if (GetPlayerBuffTexture(z) == texture) then
						texture = "Interface\\Icons\\Spell_Nature_WispSplode";
					end
				end
				if button then
					getglobal("TrapBarButton"..i.."Icon"):SetTexture(texture);
					button:SetAttribute("id",id);

					-- This function cannot be performed in combat.
					if (InCombatLockdown() == nil) then
						if ( i > TrapBar.db.profile.Number ) then
							button:SetAlpha(0);
							button:Hide();
						else
							button:Show();
							button:SetAlpha(TrapBar.db.profile.Alpha)
						end
					end
				end
			end
		end
		-- This function cannot be performed in combat.
		if ((i == 0) and (InCombatLockdown() == nil)) then
			TrapBarFrame:Hide();
		end
	end
end

function TrapBar:SPELL_UPDATE_COOLDOWN()
	for i = 1, TrapBar.db.profile.Number do
		button = getglobal("TrapBarButton"..i);
		if (button:GetAttribute("id")) then
			local cooldown = getglobal(button:GetName().."Cooldown");
			local start, duration, enable = GetSpellCooldown(button:GetAttribute("id"), SpellBookFrame.bookType);
			if (start > 0 and duration > 0) then
				cooldown:SetCooldown(start, duration);
			end
		end
	end
end